#include <bits/stdc++.h>
using namespace std;
#define int long long

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, k; cin >> n >> k;
    vector <int> v(n);
    for (int i=0;i<n;i++) {
        cin >> v[i];
    }
    for (int c=8000;c>=0;c--) {
        int x=0, k2=k-1;
        for (int i=0;i<n;i++) {
            x|=v[i];
            int z=x&c;
            if (z==c) {
                if (k2>0) {
                    k2--;
                    x=0;
                } else {
                    cout << c;
                    return 0;
                }
            }
        }
    }
}
